<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" width="500">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="140px"
    >
      <el-form-item label="锁柜序号" prop="cabinetId">
        <el-select
          v-model="formData.cabinetId"
          placeholder="请选择锁柜"
          class="!w-240px"
        >
          <el-option
            v-for="dict in cabinetOptions"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
<!--      <el-row>-->
<!--        <el-col :span="15">-->
<!--          <el-form-item label="仓位编号" prop="slotCode">-->
<!--            <el-input-->
<!--              v-model="formData.slotCode"-->
<!--              placeholder="请输入仓位编号"-->
<!--              class="!w-240px"-->
<!--            />-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--        <el-col :span="8">-->
<!--          <el-form-item label-width="80">-->
<!--            <el-switch-->
<!--              v-model="autoGenFlag"-->
<!--              active-color="#13ce66"-->
<!--              active-text="自动生成"-->
<!--              @change="handleAutoGenChange"-->
<!--            />-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--      </el-row>-->
      <el-form-item label="仓位类型" prop="slotType">
        <el-select
          v-model="formData.slotType"
          placeholder="请选择仓位类型"
          class="!w-240px"
        >
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.SLOT_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="行" prop="row">
        <el-input
          v-model="formData.row"
          placeholder="请输入行"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="列" prop="col">
        <el-input
          v-model="formData.col"
          placeholder="请输入列"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="是否被占用" prop="isOccupied">
        <el-radio-group v-model="formData.isOccupied">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.ISOCCUPIED_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item
        label="占用仓位的硬件Id"
        prop="hardwareId"
        v-if="formData.isOccupied == '1'"
      >
        <el-select
          v-model="formData.hardwareId"
          placeholder="请选择硬件ID"
          clearable
          class="!w-240px"
          @change="handleSelectHardware"
        >
          <el-option
            v-for="dict in hardwareOptions"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.SLOT_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input
          v-model="formData.remark"
          placeholder="请输入备注"
          class="!w-240px"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script lang="ts" setup>
import { ref, reactive } from 'vue'
import { DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import * as SlotApi from '@/api/hw/hardware/lockCabinet/slots'
import * as lockCabinetApi from '@/api/hw/hardware/lockCabinet/index'
import * as HardwareApi from '@/api/hw/hardware/information/index'
// import * as AutocodeApi from '@/api/system/autocode/rule'

defineOptions({ name: 'LockCabinetSlotForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const autoGenFlag = ref(false) // 是否自动生成编码

const formData = ref({
  slotId: undefined,
  slotCode: '',
  slotType: undefined,
  row: undefined,
  col: undefined,
  isOccupied: '0',
  hardwareId: undefined,
  cabinetId: undefined,
  status: '0',
  remark: ''
})

const formRules = reactive({
  // slotCode: [{ required: true, message: '仓位编号不能为空', trigger: 'blur' }],
  slotType: [{ required: true, message: '仓位类型不能为空', trigger: 'blur' }],
  cabinetId: [{ required: true, message: '锁柜序号不能为空', trigger: 'blur' }]
})

const formRef = ref() // 表单 Ref
const cabinetOptions = ref([]) // 锁柜选项
const hardwareOptions = ref([]) // 硬件选项

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await SlotApi.selectIsLockCabinetSlotsById(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await SlotApi.insertIsLockCabinetSlots(data)
      message.success(t('common.createSuccess'))
    } else {
      await SlotApi.updateIsLockCabinetSlots(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    slotId: undefined,
    slotCode: '',
    slotType: undefined,
    row: undefined,
    col: undefined,
    isOccupied: '0',
    hardwareId: undefined,
    cabinetId: undefined,
    status: '0',
    remark: ''
  }
  autoGenFlag.value = false
  formRef.value?.resetFields()
}

/** 自动生成编码 */
// const handleAutoGenChange = async (value: boolean) => {
//   if (value) {
//     formData.value.slotCode = await AutocodeApi.genCode('SLOT_CODE')
//   } else {
//     formData.value.slotCode = ''
//   }
// }

/** 选择硬件 */
const handleSelectHardware = (value: string) => {
  formData.value.hardwareId = value
}

/** 获取锁柜列表 */
const getCabinetList = async () => {
  const data = { pageNo: 1, pageSize: -1 }
  const response = await lockCabinetApi.getIsLockCabinetPage(data)
  cabinetOptions.value = response.list.map(item => ({
    value: item.id,
    label: item.cabinetName
  }))
}

/** 获取硬件列表 */
const getHardwareList = async () => {
  const data = { pageNo: 1, pageSize: -1 }
  const response = await HardwareApi.listHardware(data)
  hardwareOptions.value = response.list.map(item => ({
    value: item.id,
    label: item.hardwareName
  }))
}

/** 初始化 **/
onMounted(async () => {
  await getCabinetList()
  await getHardwareList()
})
</script>
